## open-coarrays 2.10.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

cmake_policy(VERSION 3.19...3.23)

if(DEFINED ENV{SOURCE_DATE_EPOCH})
  set(SOURCE_DATE_EPOCH "$ENV{SOURCE_DATE_EPOCH}")
endif()

set(CMAKE_SKIP_RPATH ON
  CACHE BOOL "Don't add a build-dir rpath")
set(CMAKE_BUILD_WITH_INSTALL_RPATH ON
  CACHE BOOL "Build using the install rpath")
set(CMAKE_BUILD_RPATH_USE_ORIGIN ON
  CACHE BOOL "Use relative rpaths")
# Set the type/configuration of build to perform
set ( CMAKE_CONFIGURATION_TYPES "Debug" "Release" "MinSizeRel" "RelWithDebInfo" "CodeCoverage" )
set ( CMAKE_BUILD_TYPE "Release"
  CACHE STRING "Select which configuration to build." )
set_property ( CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${CMAKE_CONFIGURATION_TYPES} )

# Add option and check environment to determine if developer tests should be run
set( _TF OFF )
if( NOT DEFINED ENV{OPENCOARRAYS_DEVELOPER})
  set ( ENV{OPENCOARRAYS_DEVELOPER} FALSE )
endif()
if($ENV{OPENCOARRAYS_DEVELOPER})
  set( _TF ON )
endif()
option(CAF_RUN_DEVELOPER_TESTS "Run tests intended only for developers" ${_TF})
mark_as_advanced(CAF_RUN_DEVELOPER_TESTS)

# Name project and specify source languages
# Parse version from .VERSION file so that more info can be added and easier to get from scripts
file(STRINGS ".VERSION" first_line
  LIMIT_COUNT 1
  )

string(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?"
  OpenCoarraysVersion "${first_line}")

if((NOT (OpenCoarraysVersion MATCHES "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?")) AND (EXISTS "${CMAKE_SOURCE_DIR}/.git"))
  find_package(Git QUIET)
  if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --abbrev=0
      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
      RESULT_VARIABLE git_status
      OUTPUT_VARIABLE git_output
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    if((git_status STREQUAL "0") AND (git_output MATCHES "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?"))
      set(OpenCoarraysVersion "${git_output}")
    endif()
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --always
      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
      RESULT_VARIABLE git_status
      OUTPUT_VARIABLE full_git_describe
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(NOT (git_status STREQUAL "0"))
      set(full_git_describe NOTFOUND)
    endif()
    # Create a source distribution target using git archive
    # e.g., `make dist` will package a release using current git state
    add_custom_target(dist
      COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_SOURCE_DIR}/cmake/makeDist.cmake" "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}"
      VERBATIM)
  else()
    message( WARNING "Could not find git executable!")
  endif()
endif()

if(NOT (OpenCoarraysVersion MATCHES "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?"))
  message( WARNING "Could not extract version from git, falling back on .VERSION, line 3.")
  file(STRINGS ".VERSION" OpenCoarraysVersion
  REGEX "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?"
  )
endif()

if(NOT full_git_describe)
  set(full_git_describe ${OpenCoarraysVersion})
endif()

string(REGEX REPLACE "-rc[0-9]+$"
       ".0" OPENCOARRAYS_CMAKE_PROJECT_VERSION
       "${OpenCoarraysVersion}")

file(READ "${CMAKE_CURRENT_LIST_DIR}/cmake/Banner.txt.in" OC_BANNER)
string(CONFIGURE "${OC_BANNER}" OC_BANNER @ONLY)
string(STRIP "${OC_BANNER}" OC_BANNER)
message(STATUS "${OC_BANNER}")

if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/.git")
  message( STATUS "Build from git repository detected")
endif()

message( STATUS "Running with CMake from: ${CMAKE_COMMAND}" )
message( STATUS "Current source dir (for OpenCoarrays): ${CMAKE_CURRENT_SOURCE_DIR}")

project(opencoarrays VERSION "${OPENCOARRAYS_CMAKE_PROJECT_VERSION}" LANGUAGES C Fortran)

if(DEFINED CMAKE_BUILD_TYPE AND "${CMAKE_BUILD_TYPE}" MATCHES "[Rr][Ee][Ll]")
  if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fno-working-directory")
  endif()
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fdebug-prefix-map=\"${CMAKE_SOURCE_DIR}\"=.")
  if(CMAKE_C_COMPILER_ID MATCHES "GNU")
    set(CMAKE_C_FLAGS       "${CMAKE_C_FLAGS} -fno-working-directory")
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fdebug-prefix-map=\"${CMAKE_SOURCE_DIR}\"=.")
endif()

message( STATUS "Building OpenCoarrays version: ${full_git_describe}" )
set(OpenCoarrays_dist_string "OpenCoarrays-${full_git_describe}")
message( STATUS "Building for target architecture: ${CMAKE_SYSTEM_PROCESSOR}" )

#Print an error message on an attempt to build inside the source directory tree:
if ("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  message(FATAL_ERROR "ERROR! "
    "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}"
    " == CMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}"
    "\nThis archive does not support in-source builds:\n"
    "You must now delete the CMakeCache.txt file and the CMakeFiles/ directory under "
    "the 'src' source directory or you will not be able to configure correctly!"
    "\nYou must now run something like:\n"
    "  $ rm -r CMakeCache.txt CMakeFiles/"
    "\n"
    "Please create a directory outside the opencoarrays source tree and build under that outside directory "
    "in a manner such as\n"
    "  $ mkdir build-opencarrays\n"
    "  $ cd build-opencoarrays\n"
    "  $ CC=gcc FC=gfortran cmake -DBUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/path/to/install/dir /path/to/opencoarrays/src/dir \n"
    "\nsubstituting the appropriate syntax for your shell (the above line assumes the bash shell)."
    )
endif()

# Silence warnings about dereferencing unset variables
if(NOT CMAKE_REQUIRED_FLAGS)
  set(CMAKE_REQUIRED_FLAGS "")
endif()
if(NOT CMAKE_REQUIRED_DEFINITIONS)
  set(CMAKE_REQUIRED_DEFINITIONS "")
endif()
if(NOT CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_REQUIRED_LIBRARIES "")
endif()
if(NOT CMAKE_REQUIRED_INCLUDES)
  set(CMAKE_REQUIRED_INCLUDES "")
endif()

#Report untested Fortran compiler unless explicitly directed to build all examples.
if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU" )
  set(gfortran_compiler true)
  set ( CMAKE_C_FLAGS_CODECOVERAGE "-fprofile-arcs -ftest-coverage -O0"
    CACHE STRING "Code coverage C compiler flags")
  set ( CMAKE_Fortran_FLAGS_CODECOVERAGE "-fprofile-arcs -ftest-coverage -O0"
    CACHE STRING "Code coverage Fortran compiler flags")
else()
  message(WARNING
    "\n"
    "Attempting to build with untested Fortran compiler: ${CMAKE_Fortran_COMPILER_ID}. "
    "Please report any failures to opencoarrays@googlegroups.com\n\n"
  )
endif()

#-----------------------------------------------------------------
# Set CMAKE_Fortran_COMPILER_VERSION if CMake doesn't do it for us
#-----------------------------------------------------------------
if (  NOT CMAKE_Fortran_COMPILER_VERSION )
  if ( NOT (CMAKE_VERSION VERSION_LESS 3.3.1) )
    message( AUTHOR_WARNING
     "CMake ${CMAKE_VERSION} should know about Fortran compiler versions but is missing CMAKE_Fortran_COMPILER_VERSION variable."
    )
  endif()
  # No CMAKE_Fortran_COMPILER_VERSION set, build our own
  # Try extracting it directly from ISO_FORTRAN_ENV's compiler_version
  # Write program for introspection
  file( WRITE "${CMAKE_BINARY_DIR}/get_compiler_ver.f90"
    "program main
     use iso_fortran_env, only: compiler_version, output_unit
     write(output_unit,'(a)') compiler_version()
end program"
  )
  try_run( PROG_RAN COMPILE_SUCCESS
    "${CMAKE_BINARY_DIR}" "${CMAKE_BINARY_DIR}/get_compiler_ver.f90"
    RUN_OUTPUT_VARIABLE VER_STRING
  )
  if ( COMPILE_SUCCESS )
    string( REGEX MATCH "[0-9]+\\.[0-9]+(\\.[0-9]+)?"
      DETECTED_VER "${VER_STRING}"
    )
    message( STATUS "Detected Fortran compiler as ${VER_STRING}" )
    message( STATUS "Extracted version number: ${DETECTED_VER}" )
  endif()
  if( ( NOT COMPILE_SUCCESS ) OR ( NOT DETECTED_VER ) )
    message( WARNING "Could not reliably detect Fortran compiler version. We'll infer it from
the C compiler if it matches the Fortran compiler ID." )
  endif()
  if( "${CMAKE_C_COMPILER_ID}" MATCHES "${CMAKE_Fortran_COMPILER_ID}" )
    set( DETECTED_VER "${CMAKE_C_COMPILER_VERSION}" )
  else()
    message( FATAL_ERROR "Exhausted all possible means of detecting the Fortran compiler version, cannot proceed!" )
  endif()
  set( CMAKE_Fortran_COMPILER_VERSION "${DETECTED_VER}" )
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug|DEBUG|debug")
  add_definitions(-DEXTRA_DEBUG_OUTPUT)
  set(IMPI_BUILD debug)
else()
  set(IMPI_BUILD release)
endif()

  # We have populated CMAKE_Fortran_COMPILER_VERSION if it was missing
  if(gfortran_compiler AND (CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER 5.0.0))
    set(opencoarrays_aware_compiler true)
    add_definitions(-DPREFIX_NAME=_gfortran_caf_)
  else()
    set(opencoarrays_aware_compiler false)
    add_definitions(-DPREFIX_NAME=_caf_extensions_)
  endif()
  if(gfortran_compiler AND (CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 5.4.0))
    # GCC patch to fix issue accepted for 5.4 release
    # See https://github.com/sourceryinstitute/opencoarrays/issues/28 and
    # https://groups.google.com/forum/#!msg/opencoarrays/RZOwwYTqG80/46S9eL696dgJ
    message( STATUS "Disabling optimization flags due to GCC < 5.4 bug")
    set(CMAKE_Fortran_FLAGS_RELEASE -O0
      CACHE STRING "Flags used by the compiler during release builds." FORCE)
    set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-g -DNDEBUG -O0"
      CACHE STRING "Flags used by the compiler during release builds with debug info" FORCE)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -O0")
  endif()
  if ( gfortran_compiler AND ( NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0 ) )
    add_definitions(-DGCC_GE_7) # Tell library to build against GFortran 7.x bindings b/c we might be using clang for C
  endif()
  if ( gfortran_compiler AND ( NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 8.0.0 ) )
    add_definitions(-DGCC_GE_8) # Tell library to build against GFortran 8.x bindings w/ descriptor change
  endif()

if(gfortran_compiler)
  set(OLD_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_REQUIRED_FLAGS -fcoarray=single)
endif()
include(CheckFortranSourceCompiles)
CHECK_Fortran_SOURCE_COMPILES("
  program main
    implicit none
    integer :: i
    i = this_image()
  end program
" Check_Simple_Coarray_Fortran_Source_Compiles
  SRC_EXT F90)
if(gfortran_compiler)
  set (CMAKE_REQUIRED_FLAGS ${OLD_REQUIRED_FLAGS})
  unset(OLD_REQUIRED_FLAGS)
endif()


#----------------------------------------------------------------------------
# Find MPI and set some flags so that FC and CC can point to gfortran and gcc
#----------------------------------------------------------------------------

# If the user passes FC=mpifort etc. check and prefer that location
get_filename_component( FTN_COMPILER_NAME "${CMAKE_Fortran_COMPILER}"
  NAME )
get_filename_component( C_COMPILER_NAME "${CMAKE_C_COMPILER}"
  NAME )
get_filename_component( FTN_COMPILER_DIR "${CMAKE_Fortran_COMPILER}"
  REALPATH )
get_filename_component( C_COMPILER_DIR "${CMAKE_C_COMPILER}"
  REALPATH )

if (FTN_COMPILER_NAME MATCHES "^[mM][pP][iI]")
  message( DEPRECATION "Setting the Fortran compiler to an MPI wrapper script is deprecated!")
  set (MPI_Fortran_COMPILER "${CMAKE_Fortran_COMPILER}")
endif()
if (C_COMPILER_NAME MATCHES "^[mM][pP][iI]")
  message( DEPRECATION "Setting the Fortran compiler to an MPI wrapper script is deprecated!")
  set (MPI_C_COMPILER "${CMAKE_C_COMPILER}")
endif()

if(WIN32) # Only support building with GCC & GFortran using Intel MPI (OneAPI)
  # Here we assume Intel ONEAPI and the environment is loaded
  set( MPI_ASSUME_NO_BUILTIN_MPI TRUE )
  set( MPI_CXX_SKIP_MPICXX TRUE )
  cmake_path(SET MPI_ROOT NORMALIZE "$ENV{I_MPI_ROOT}")
  set (IMPI_LIB_DIR "${MPI_ROOT}/lib/${IMPI_BUILD}")
  set (IMPI_DLL_DIR "${MPI_ROOT}/bin/${IMPI_BUILD}")

  find_library(IMPI_LIB
    "impi.lib"
    HINTS "${IMPI_LIB_DIR}"
    DOC "Location of the Intel MPI impi.lib file"
    REQUIRED
    NO_DEFAULT_PATH)

  find_file(IMPI_DLL
    "impi.dll"
    HINTS "${IMPI_DLL_DIR}"
    DOC "Location of the Intel MPI impi.dll file"
    REQUIRED

=== src/CMakeLists.txt ===
add_subdirectory(application-binary-interface )
add_subdirectory(runtime-libraries )
add_subdirectory(tests)

set(N_CPU ${N_CPU} PARENT_SCOPE)
set(HOST_NAME ${HOST_NAME} PARENT_SCOPE)

if(openmpi)
  set(openmpi ${openmpi} PARENT_SCOPE)
endif()

=== src/runtime-libraries/gasnet/CMakeLists.txt ===
add_library(caf_gasnet gasnet.c ../common/caf_auxiliary.c)

=== src/tests/performance/BurgersMPI/CMakeLists.txt ===
set(include_directory ${CMAKE_CURRENT_SOURCE_DIR}/../../integration/pde_solvers/include-files)
set(library_directory ${CMAKE_CURRENT_SOURCE_DIR}/../../integration/pde_solvers/library)
set(config_directory  ${CMAKE_CURRENT_BINARY_DIR}/../../integration/pde_solvers/library)

if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Cray")
  configure_file(${include_directory}/cray_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Intel")
  configure_file(${include_directory}/intel_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
  configure_file(${include_directory}/gfortran_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "VisualAge|XL")
  configure_file(${include_directory}/ibm_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "PGI")
  configure_file(${include_directory}/portlandgroup_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "NAG")
  configure_file(${include_directory}/nag_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
else()
  message ("Unknown Fortran compiler: ${CMAKE_Fortran_COMPILER_ID}")
endif()

add_executable( mpi_burgers_pde
  main.F90
  ${library_directory}/object_interface.F90
  ${library_directory}/ForTrilinos_assertion_utility.F90
  ${library_directory}/ForTrilinos_error.F90
  kind_parameters.F90
  shared.F90
  mpi_module.F90
  mpi_share.F90
  input_file.F90
  periodic_2nd_order.F90
)
target_include_directories(mpi_burgers_pde PRIVATE ${config_directory})

=== src/tests/performance/mpi_dist_transpose/CMakeLists.txt ===
IF (("${CMAKE_SYSTEM_NAME}" MATCHES "Linux" ) AND (${HIGH_RESOLUTION_TIMER}))
  message("\nUsing assembly-language timers that tick once per clock cycle.")
  message("WARNING: walltime.o is designed for an x86 CPU with a 3.6 GHz clock.")
  message("Because modern processors can throttle their clock spees, do not ")
  message("rely on this timer for an absolute value, but it can be useful for ")
  message("comparison or relative execution execution times on the same platform.\n")
  add_executable(mpi_distributed_transpose
    mpi_distributed_transpose.F90
    walltime.o
    )
  target_compile_definitions(mpi_distributed_transpose
    PRIVATE -DHAVE_WALLTIME)
else()
  add_executable(mpi_distributed_transpose
    mpi_distributed_transpose.F90
  )
endif()

=== src/tests/regression/reported/CMakeLists.txt ===
caf_compile_executable(co_reduce-factorial issue-172-wrong-co_reduce.F90)
caf_compile_executable(co_reduce-factorial-int8 issue-172-wrong-co_reduce-int8.F90)
caf_compile_executable(co_reduce-factorial-int64 issue-172-wrong-co_reduce-int64.F90)
caf_compile_executable(source-alloc-sync issue-243-source-allocation-no-sync.f90)
caf_compile_executable(convert-before-put issue-292-convert-type-before-put.f90)
caf_compile_executable(issue-422-send issue-422-send.F90)
caf_compile_executable(issue-422-send-get issue-422-send-get.F90)
caf_compile_executable(issue-488-multi-dim-cobounds issue-488-multi-dim-cobounds.f90)
caf_compile_executable(issue-493-coindex-slice issue-493-coindex-slice.f90)
caf_compile_executable(issue-503-multidim-array-broadcast issue-503-multidim-array-broadcast.f90)
caf_compile_executable(issue-503-non-contig-red-ndarray issue-503-non-contig-red-ndarray.f90)
caf_compile_executable(issue-322-non-coarray-vector-idx-lhs issue-322-non-coarray-vector-idx-lhs.f90)
caf_compile_executable(issue-552-send_by_ref-singleton issue-552-send_by_ref-singleton.f90)
caf_compile_executable(issue-511-incorrect-shape issue-511-incorrect-shape.f90)
caf_compile_executable(issue-700-allow-multiple-scalar-dim-array-gets issue-700-allow-multiple-scalar-dim-array-gets.f90)
if (gfortran_compiler AND (NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0))
  caf_compile_executable(issue-515-mimic-mpi-gatherv issue-515-mimic-mpi-gatherv.f90)
endif()
caf_compile_executable(issue-762-mpi-crashing-on-exit issue-762-mpi-crashing-on-exit.f90)

=== src/tests/unit/collectives/CMakeLists.txt ===
caf_compile_executable(co_sum_test co_sum.F90)
caf_compile_executable(co_broadcast_test co_broadcast.F90)
caf_compile_executable(co_broadcast_derived_type_test co_broadcast_derived_type.f90)
if((gfortran_compiler AND (NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 10.0.0)) OR (CAF_RUN_DEVELOPER_TESTS OR $ENV{OPENCOARRAYS_DEVELOPER}))
  caf_compile_executable(co_broadcast_allocatable_components_test co_broadcast_allocatable_components.f90)
endif()
if((gfortran_compiler AND (NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 11.2.2)) OR (CAF_RUN_DEVELOPER_TESTS OR $ENV{OPENCOARRAYS_DEVELOPER}))
  caf_compile_executable(co_broadcast_alloc_mixed co_broadcast_alloc_mixed.f90)
endif()
caf_compile_executable(co_min_test co_min.F90)
caf_compile_executable(co_max_test co_max.F90)
caf_compile_executable(co_reduce_test co_reduce.F90)
caf_compile_executable(co_reduce_res_im co_reduce_res_im.F90)
caf_compile_executable(co_reduce_string co_reduce_string.f90)

=== src/tests/integration/pde_solvers/library/CMakeLists.txt ===
add_library(mofo
   ForTrilinos_assertion_utility.F90
   ForTrilinos_error.F90
   object_interface.F90
   co_object_interface.F90
#  parse_command_line.F90
)

=== debian/changelog ===
open-coarrays (2.10.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 12 Oct 2022 11:36:01 +0100

=== debian/control ===
Source: open-coarrays
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
 dh-buildinfo,
 dh-sequence-fortran-mod,
 gfortran | fortran-compiler,
 libopenmpi-dev,
 libmpich-dev,
 cmake (>= 3.3.1), 
 openssh-client,
Standards-Version: 4.6.1
Homepage: https://www.opencoarrays.org/
Vcs-Browser: https://salsa.debian.org:/science-team/open-coarrays
Vcs-Git: https://salsa.debian.org:/science-team/open-coarrays.git -b debian/latest


Package: libcoarrays-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, gfortran | fortran-compiler
Description: Co-Array Fortran libraries 
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package contains shared development files (headers and fortran modules)

Package: libcoarrays-openmpi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, gfortran  | fortran-compiler, openmpi-bin,
 libcaf-openmpi-3 (= ${binary:Version}), libcoarrays-dev
Description: Co-Array Fortran libraries  - development files (OpenMPI)
 OpenCoArrays is an open-source software project that supports the 
 coarray Fortran (CAF) parallel programming features of the Fortran 2008 
 standard and several features proposed for Fortran 2015 in the draft 
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for Fortran to build parallel
 CAF programs built on top of OpenMPI.

Package: libcaf-openmpi-3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libcoarrays0d (<< 1.8.10)
Replaces: libcoarrays0d (<< 1.8.10)
Description: Co-Array Fortran libraries  (OpenMPI)
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for Fortran to build parallel
 CAF programs built on top of OpenMPI.

Package: libcoarrays-mpich-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, gfortran | fortran-compiler, mpich,
 libcaf-mpich-3 (= ${binary:Version}), libcoarrays-dev
Description: Co-Array Fortran libraries for - development files (MPICH)
 OpenCoArrays is an open-source software project that supports the 
 coarray Fortran (CAF) parallel programming features of the Fortran 2008 
 standard and several features proposed for Fortran 2015 in the draft 
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for Fortran to build parallel
 CAF programs built on top of MPICH MPI.

Package: libcaf-mpich-3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libcoarrays0d (<< 1.8.10)
Replaces: libcoarrays0d (<< 1.8.10)
Description: Co-Array Fortran libraries  (MPICH)
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for Fortran to build parallel
 CAF programs built on top of MPICH MPI.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
VERSION:=$(shell dpkg-parsechangelog --show-field Version)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
DESTDIR:=$(CURDIR)/debian/tmp
AUTOGENERATED:= caf-mpich.pc	caf-openmpi.pc \
	libcoarrays-openmpi-dev.postinst libcoarrays-openmpi-dev.prerm \
	libcoarrays-mpich-dev.postinst libcoarrays-mpich-dev.prerm \
	caf.openmpi caf.mpich

# Set default f95 compiler
F95 ?= /usr/bin/f95

GFORTRAN_VERSION:=$(readlink /usr/bin/gfortran)

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake --no-parallel 

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# DISABLED_TESTS:= "powerpc alpha"

MPICH_CFLAGS=$(dpkg-buildpackage --get CFLAGS) $(shell pkg-config mpich --cflags)
MPICH_FCFLAGS=$(dpkg-buildpackage --get FCFLAGS) $(shell pkg-config mpich-fort --cflags)
OPENMPI_CFLAGS=$(dpkg-buildpackage --get CFLAGS) $(shell pkg-config ompi-c --cflags)
OPENMPI_FCFLAGS=$(dpkg-buildpackage --get FCFLAGS) $(shell pkg-config ompi-fort --cflags)

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@DEB_HOST_MULTIARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in | \
		sed -e 's%@VERSION@%${VERSION}%g'   | \
		sed -e 's%@GFORTRAN_VERSION@%${GFORTRAN_VERSION}%g' > debian/$$f ; \
                done
	CXX=mpicxx.mpich CC=mpicc.mpich FC=mpif90.mpich  \
		dh_auto_configure --builddirectory=build-mpich -- \
			-DCAF_LIB_NAME=caf_mpich 
	CXX=mpicxx.openmpi CC=mpicc.openmpi FC=mpif90.openmpi  \
		dh_auto_configure --builddirectory=build-openmpi -- 	\
			-DCAF_LIB_NAME=caf_openmpi
	#dh_auto_configure --builddirectory=build-mpich --  \
	#		-DMPI_C_COMPILER=mpicc.mpich -DMPI_Fortran_COMPILER=mpifort.mpich \
	#		-DCMAKE_C_FLAGS="$(MPICH_CFLAGS)" -DCMAKE_Fortran_FLAGS="$(MPICH_FCFLAGS)" \
	#		-DCAF_LIB_NAME=caf_mpich 
	#dh_auto_configure --builddirectory=build-openmpi -- \
	#		-DMPI_C_COMPILER=mpicc.openmpi -DMPI_Fortran_COMPILER=mpifort.openmpi \
	#		-DCMAKE_C_FLAGS="$(OPENMPI_CFLAGS)" -DCMAKE_Fortran_FLAGS="$(OPENMPI_FCFLAGS)" \
	#		-DCAF_LIB_NAME=caf_openmpi 

override_dh_auto_build:
	dh_auto_build --builddirectory=build-mpich
	dh_auto_build --builddirectory=build-openmpi

override_dh_auto_install:
	cp debian/caf.openmpi build-openmpi/bin/caf
	cp debian/caf.mpich build-mpich/bin/caf
	dh_auto_install --builddirectory=build-mpich
	dh_auto_install --builddirectory=build-openmpi
	rm  $(DESTDIR)/$(LIBDIR)/libopencoarrays_mod.a
	mkdir -p $(DESTDIR)/$(LIBDIR)/open-coarrays/mpich/lib $(DESTDIR)/$(LIBDIR)/open-coarrays/openmpi/lib/
	mv build-mpich/lib/$(DEB_HOST_MULTIARCH)/libopencoarrays_mod.a   $(DESTDIR)/$(LIBDIR)/open-coarrays/mpich/lib/libopencoarrays_mod_mpich.a
	mv build-openmpi/lib/$(DEB_HOST_MULTIARCH)/libopencoarrays_mod.a $(DESTDIR)/$(LIBDIR)/open-coarrays/openmpi/lib/libopencoarrays_mod_openmpi.a

override_dh_auto_clean:
	dh_clean
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	rm -rf build-*

override_dh_auto_test:
ifneq (,$(findstring  "$(DEB_HOST_ARCH)",$(DISABLED_TESTS)))
	@echo "Tests disabled on this arch: known failures being investigated"
else
	@echo "Tests may hang/timeout due to lack of processors. "
	-dh_auto_test --timeout 30
endif

## open-coarrays 2.10.2%2Bds

=== debian/changelog ===
open-coarrays (2.10.2+ds-4) unstable; urgency=medium

  * Drop kfreebsd, ia64 support
  * Drop B-D on dh-buildinfo
  * Sourceful upload to regenerate d/control. Closes: #1094619

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 18 Dec 2024 12:51:21 +0000

open-coarrays (2.10.2+ds-3) unstable; urgency=medium

  * Update the d/control for 32-bit arch change. Closes: #1087966
  * Simplify autogeneration rules
  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Nov 2024 10:31:05 +0000

open-coarrays (2.10.2+ds-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062825

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 02:30:57 +0000

open-coarrays (2.10.2+ds-2) unstable; urgency=medium

  * New upstream release Cbinaries removed)
  * Update d/watch to version 4, strip +ds in dmangle
  * Standards-Version: 4.6.2
  * For dh_fortran_mod, provides fortran:Depends
  * Drop obsolete Breaks/Depends in d/control
  * Add lintian-overrides on no-code-section

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 24 Jan 2024 09:28:13 +0000
